<? 
    //LIME : Login Management Engine
    //
    //Reference
    //  bool Login(username,password)
    //  void Logout()
    //  bool IsLoggedIn()
    //  string GetUsername()
    //  
    
    session_start();
    
    //include general config file
    include(".lime-config/lime.php");
    
    //data paths
    $PATH_DATA  = ".lime-data";
    $PATH_USERS = ".lime-users";
    $PATH_TEMP  = ".lime-temp";
    
    //set file locations
    $userlist = "$PATH_DATA/users";
    $userpath = "$PATH_USERS/";
    $sessiondata = "$PATH_TEMP/".session_id();
    
    //clean up session files
    $dp=opendir($PATH_TEMP);
    while($file=readdir($dp))
    {
    	if($file!="." && $file!="..")
    	{
    	    $file="$PATH_TEMP/$file";
            if(time()-filemtime($file)>$config["timeout"])
               unlink($file);
        }
    }
    closedir($dp);
    
    //attempts to login with given username and password
    //if succeeds, stores appropriate session information
    //returns 0 if ail, 1 if succeeded
    function Login($username, $password)
    {
    	global $userlist, $sessiondata;
        $users=file($userlist);
        foreach($users as $line)
        {
    	    list($user,$pass)=explode("|",chop($line));
    	    if( ($username==$user) && ($password==$pass) )
    	    {
    	        //store session id
    	        $fp=fopen("$sessiondata","w");
    	        fwrite($fp,"$username\n");
    	        fclose($fp);
    	        return true;
    	    }
        }
        return false;
    }
    
    //Logs out, kill session file
    function Logout()
    {
    	global $sessiondata;
    	//delete sessiondata file
        if(file_exists($sessiondata)) unlink($sessiondata);
    }
    
    //checks if logged in
    function IsLoggedIn()
    {
        return GetUsername()!="";
    }
    
    //returns username if logged in
    function GetUsername()
    {
    	global $sessiondata;
    	if(file_exists($sessiondata))
        {
            $data=file($sessiondata);
            return chop($data[0]);
        }
        else return "";
    }
    
    //used for multi-lined or binary data
    //returns the full contents of the file $userdata.ext
    function GetUserData($ext)
    {
    	if(!IsLoggedIn()) return "";
    	global $userpath;
        $file=$userpath.GetUsername().".$ext"; //basic user datafile
    	if(file_exists($file))
    	{
    	    $fp=fopen($file,"r");
    	    $data=fread($fp,filesize($file));
    	    fclose($fp);
    	    return $data;
    	}
    }
    
    //used for single lined settings
    //ext can be provided for a custom settings file
    function GetUserSetting($setting, $ext="")
    {
    	if(!IsLoggedIn()) return "";
    	global $userpath;
    	$file=$userpath.GetUsername().".$ext";
    	if(file_exists($file))
    	{
    	    $data=file($file);
    	    foreach($data as $line)
    	    {
    	        list($property,$value)=explode("=",chop($line));
    	        if($setting==$property) return $value;
    	    }
    	}
    	return "";
    }
    
    //returns an associative array of all settings
    function GetUserSettings($ext="")
    {
    	if(!IsLoggedIn()) return "";
    	global $userpath;
    	$file=$userpath.GetUsername().".$ext";
    	if(!file_exists($file)) return;
    	$data=file($file);
        foreach($data as $line)
    	{
    	    list($property,$value)=explode("=",chop($line));
    	    $settings[$property]=$value;
    	}
    	return $settings;
    }
    
    function SetUserData($data,$ext)
    {
    	if(!IsLoggedIn()) return;
        global $userpath;
    	$file=$userpath.GetUsername().".$ext";
    	$fp=fopen($file,"w");
    	fwrite($fp,$data);
    	fclose($fp);
    }
    
    function SetUserSetting($setting,$value,$ext="")
    {
    	if(!IsLoggedIn()) return;
    	global $userpath;
    	$file=$userpath.GetUsername().".$ext";
    	$settings=GetUserSettings($ext);
    	$settings[$setting]=$value;
    	SetUserSettings($settings,$ext);
    }
    
    function SetUserSettings($settings,$ext="")
    {
    	if(!IsLoggedIn()) return;
    	global $userpath;
    	$file=$userpath.GetUsername().".$ext";
    	$fp=fopen($file,"w");
        foreach($settings as $setting=>$value)
            fwrite($fp,"$setting=$value\n");
        fclose($fp);
    }
    
    function SetSessionSetting($setting, $value)
    {
    	global $$setting;
    	session_register($setting);
    	$$setting=$value;
    }
    
    function GetSessionSetting($setting)
    {
    	global $$setting;
        return $$setting;
    }
?>